;=======================================================================
;   8_Bit_JCS_CPU support for fasmg (19.11.2016)
;=======================================================================

A equ 0
B equ 1
C equ 2
D equ 3

a equ 0
b equ 1
c equ 2
d equ 3

Z equ 0
S equ 2

ZF equ 0
AF equ 1
SF equ 2
CF equ 3

z equ 0
s equ 2

zf equ 0
af equ 1
sf equ 2
cf equ 3

ZY equ 0
AY equ 1
SY equ 2
CY equ 3

zy equ 0
ay equ 1
sy equ 2
cy equ 3

NZ equ 4
NA equ 5
NS equ 6
NC equ 7

nz equ 4
na equ 5
ns equ 6
nc equ 7

flag_z  equ 0
flag_a  equ 1
flag_s  equ 2
flag_c  equ 3

flag_nz equ 4
flag_na equ 5
flag_ns equ 6
flag_nc equ 7

ds equ rb ; reserve n bytes
DS equ rb ; reserve n bytes

;-----------------------------------------------------------------------
macro SBB r1,r2 {
    db 00h + (r1 shl 2) + r2 }
macro ADC r1,r2 {
    db 010h + (r1 shl 2) + r2 }
macro AND r1,r2 {
    db 020h + (r1 shl 2) + r2 }
macro XOR r1,r2 {
    db 030h + (r1 shl 2) + r2 }
macro OR  r1,r2 {
    db 040h + (r1 shl 2) + r2 }
macro RAR r1,r2 {
    db 050h + (r1 shl 2) + r2 }
macro RAL r1,r2 {
    db 060h + (r1 shl 2) + r2 }
macro CMP r1,r2 {
    db 070h + (r1 shl 2) + r2 }
macro MVI r1,imm {
    db 080h + (r1 shl 2) + r1,imm }
macro MOV r1,r2 {
    db 080h + (r1 shl 2) + r2 }
macro INC r1 {
    db 090h + r1 }
macro INR r1 {
    db 090h + r1 }
macro DEC r1 {
    db 094h + r1 }
macro DCR r1 {
    db 094h + r1 }
macro LDAX r1 {
    db 098h + r1 }
macro STAX r1 {
    db 09Ch + r1 }
macro IN r1,imm {
    db 0A0h + r1,imm }
macro OUT r1,imm {
    db 0A4h + r1,imm }
;macro OUT imm,r1 {
;    db 0A4h + r1,imm }
macro JMPS r1 {
    db 0A8h + r1 }
macro NOP {
    db 0ACh }
macro XCHG r1,r2 {
    db 0ACh + r2 }
macro SKIP r1 {
    db 0B0h + r1 }
macro CLC {
    db 0B9h }
macro STC {
    db 0BAh }
macro CMC {
    db 0BCh }
;-----------------------------------------------------------------------
macro LDA imm  {
       dw 0C0h or (imm shr 4 and 0F0h) or (imm and 0FFh) shl 8  }
macro STA imm  {
       dw 0D0h or (imm shr 4 and 0F0h) or (imm and 0FFh) shl 8  }
macro JSR imm  {
       dw 0E0h or (imm shr 4 and 0F0h) or (imm and 0FFh) shl 8  }
macro CALL imm  {
       dw 0E0h or (imm shr 4 and 0F0h) or (imm and 0FFh) shl 8  }
macro JMP imm  {
       dw 0F0h or (imm shr 4 and 0F0h) or (imm and 0FFh) shl 8  }
;-----------------------------------------------------------------------
macro sbb r1,r2 {
    db 00h + (r1 shl 2) + r2 }
macro adc r1,r2 {
    db 010h + (r1 shl 2) + r2 }
macro and r1,r2 {
    db 020h + (r1 shl 2) + r2 }
macro xor r1,r2 {
    db 030h + (r1 shl 2) + r2 }
macro or  r1,r2 {
    db 040h + (r1 shl 2) + r2 }
macro rar r1,r2 {
    db 050h + (r1 shl 2) + r2 }
macro ral r1,r2 {
    db 060h + (r1 shl 2) + r2 }
macro cmp r1,r2 {
    db 070h + (r1 shl 2) + r2 }
macro mvi r1,imm {
    db 080h + (r1 shl 2) + r1,imm }
macro mov r1,r2 {
    db 080h + (r1 shl 2) + r2 }
macro inc r1 {
    db 090h + r1 }
macro inr r1 {
    db 090h + r1 }
macro dec r1 {
    db 094h + r1 }
macro dcr r1 {
    db 094h + r1 }
macro ldax r1 {
    db 098h + r1 }
macro stax r1 {
    db 09Ch + r1 }
macro in r1,imm {
    db 0A0h + r1,imm }
macro out r1,imm {
    db 0A4h + r1,imm }
macro out imm,r1 {
    db 0A4h + r1,imm }
macro jmps r1 {
    db 0A8h + r1 }
macro nop {
    db 0ACh }
macro xchg r1,r2 {
    db 0ACh + r2 }
macro skip r1 {
    db 0B0h + r1 }
macro clc {
    db 0B9h }
macro stc {
    db 0BAh }
macro cmc {
    db 0BCh }
;-----------------------------------------------------------------------
macro lda imm  {
       dw 0C0h or (imm shr 4 and 0F0h) or (imm and 0FFh) shl 8  }
macro sta imm  {
       dw 0D0h or (imm shr 4 and 0F0h) or (imm and 0FFh) shl 8  }
macro jsr imm  {
       dw 0E0h or (imm shr 4 and 0F0h) or (imm and 0FFh) shl 8  }
macro call imm  {
       dw 0E0h or (imm shr 4 and 0F0h) or (imm and 0FFh) shl 8  }
macro jmp imm  {
       dw 0F0h or (imm shr 4 and 0F0h) or (imm and 0FFh) shl 8  }
;-----------------------------------------------------------------------